-- Last modification : 2010/12/23 at 21:02:56
-- Script created by Samy the 2010/10/30 at 18:14:24
-- with PGE Lua v0.02 and PGE Editor v0.03

collectgarbage ()

pge.dir.chdir ("polices")
police= pge.font.load("verdana.ttf", 10, PGE_RAM)
pol2= pge.font.load("pacman.ttf", 35, PGE_RAM)
pol3= pge.font.load("pacman.ttf", 50, PGE_RAM)
pge.dir.chdir ("..")


local QUITTER= false
local TEMPS_MV= 0.017 --intervalle entre chaque mouvement du joueur
local ENNEMIS= 4
local LARGEUR= 8
local STEP= 2
local TEMPS_S_DEB= 3
local TEMPS_SORTIE= 6
local TEMPS_FANT= 8
local TEMPS_F_CLI= .8
local NBR_F_CLI= 4
local TEMPS_DEP= 5
local BOITEX= 13
local BOITEY= 15
local DETECTION= 15
local RATIO= 272/480

local ABD= 1
local ABG= 2
local AHG= 4
local AHD= 3
local HH= 5
local HB= 6
local VG= 7
local VD= 8
local CEN= 9
local BASE= 10
local PAC= 11
local BON= 12
local PP= -1
local GP= -2
local P= -3
local TRANS= -4


local GAUCHE= -1
local DROITE= 1
local HAUT= -2
local BAS= 2


local time= pge.timer.create ()       --timer general
local t_score= pge.timer.create ()       --timer pour l'affichage des scores
local bonus= {time= pge.timer.create (), pict= pge.texture.load ("images/cerise.png", PGE_RAM), val= 1600, etat= false, duree= 10}
local AI= {}
for i= 1, 4 do
   AI[i]= {pict, x= BOITEX, y= BOITEY, dx= 0, dy= 0, dep= 0, chemin= {}, compt= i*4, ancien= 0, pict_sav= pge.texture.create (8+2, 8+2, PGE_PIXEL_FORMAT_4444, PGE_VRAM), statut= "deb", time= pge.timer.create (), decal= 0}
   AI[i].time:update ()
end
local p= {x= 2, y= 2, dx= 0, dy= 0, dep= 0, f_dep= 0, statut= false, time= pge.timer.create ()}
local deb= {x= 14, y= 18}
local larg, haut= 1, 1
local anim= 1
local blanc= pge.gfx.createcolor (255, 255, 255)
local noir= pge.gfx.createcolor (0, 0, 0)
local rouge= pge.gfx.createcolor (255, 0, 0)
local vert= pge.gfx.createcolor (0, 255, 0)
local nbr_attrape= 0
local nbr_tres= 0
local nbre_niv= 0
local max_level= 0
local max_score= 0
local vies= 5
local niveau= {}
for i= 1, 34 do
   niveau[i]= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
end
local transp= {}
local opt= {vol= 35, speed= 1.5, ia= 5, screen= 3, transy= 0, decalage= {temps= pge.timer.create (), val= 0}, music= true, sound= true}
local score= 0
local cumul= 200


--chargement des images 
if not pict then
   pict= pge.texture.create (280, 272, PGE_PIXEL_FORMAT_4444, PGE_VRAM)
end
if not p_score then
   p_score= pge.texture.create (80, 30, PGE_PIXEL_FORMAT_4444, PGE_VRAM)
end
pict:tovram ()
pge.dir.chdir ("images")
fond= pge.texture.load ("fond.png", PGE_RAM)
bord2= pge.texture.load ("bord2.png", PGE_RAM)
logo= pge.texture.load ("logo.png", PGE_RAM)
cen= pge.texture.load ("cen.png", PGE_RAM)
abd= pge.texture.load ("abd.png", PGE_RAM)
abg= pge.texture.load ("abg.png", PGE_RAM)
ahg= pge.texture.load ("ahg.png", PGE_RAM)
ahd= pge.texture.load ("ahd.png", PGE_RAM)
hh= pge.texture.load ("hh.png", PGE_RAM)
hb= pge.texture.load ("hb.png", PGE_RAM)
vg= pge.texture.load ("vg.png", PGE_RAM)
vd= pge.texture.load ("vd.png", PGE_RAM)
pac= {
   pge.texture.load ("pac.png", PGE_RAM), 
   pge.texture.load ("pac1.png", PGE_RAM), 
   pge.texture.load ("pac2.png", PGE_RAM), 
   pge.texture.load ("pac3.png", PGE_RAM)
}
trans= pge.texture.load ("trans.png", PGE_RAM)
hp= pge.texture.load ("hp.png", PGE_RAM)
img= {pge.texture.load ("blinky.png", PGE_RAM), pge.texture.load ("pinky.png", PGE_RAM), pge.texture.load ("inky.png", PGE_RAM), pge.texture.load ("clyde.png", PGE_RAM)}
fant= pge.texture.load ("fant.png", PGE_RAM)
fant2= pge.texture.load ("fant2.png", PGE_RAM)
yeux= {pge.texture.load ("yhg.png", PGE_RAM), pge.texture.load ("yhd.png", PGE_RAM), pge.texture.load ("ybd.png", PGE_RAM), pge.texture.load ("ybg.png", PGE_RAM)}
pge.dir.chdir ("..")


--chargement des sons
pge.dir.chdir ("sons")
local dot= pge.wav.load ("dot.wav")
local energ= pge.wav.load ("energ.wav")
local bonu= pge.wav.load ("bonu.wav")
local attrap= pge.wav.load ("attrap.wav")
pge.dir.chdir ("..")

------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------

function AdapterVue ()
   opt.transy= (p.y+p.dy/10)*LARGEUR-((larg*LARGEUR+1)*RATIO)/2+pac[anim]:height ()/2
   if opt.transy<0 then
      opt.transy= 0
   end
   if opt.transy>(haut*LARGEUR+1)-((haut*LARGEUR+1))/2+pac[anim]:height ()/2 then
      opt.transy= (haut*LARGEUR+1)-((haut*LARGEUR+1))/2+pac[anim]:height ()/2
   end
end


function Dessiner ()
   pict:settarget ()
   if nbr_attrape==70 or nbr_attrape==170 then
      bonus.etat= true
      bonus.time:update ()
      bonus.pict:activate ()
      bonus.pict:draweasy ((deb.x-1)*LARGEUR, (deb.y-1)*LARGEUR)
      if opt.sound then
         bonu:play ()
      end
   end
   if bonus.etat then
      if bonus.time:peekdelta ()>bonus.duree then
         bonus.etat= false
         Trou (deb.x, deb.y)
      else 
         if p.x==deb.x and p.y==deb.y then
            score= score + bonus.val
            Trou (deb.x, deb.y)
            AfficherScore (bonus.val)
            pict:settarget ()
            bonus.etat= false
            if opt.sound then
               attrap:play ()
            end
         end
      end
   end
   for i= 1, #AI do
      if AI[i].statut~="retour" then
         AI[i].pict:activate ()
         AI[i].pict:draw ((AI[i].x-1)*LARGEUR+AI[i].dx, (AI[i].y-1)*LARGEUR+AI[i].dy)
      end
      tx= 0
      if not p.statut or AI[i].statut~="fuite" then
         if AI[i].x>p.x then
            if AI[i].y<p.y then
               tx= 4
            else 
               tx= 1
            end
         else 
            if AI[i].y<p.y then
               tx= 3
            else 
               tx= 2
            end
         end
         yeux[tx]:activate ()
         yeux[tx]:draw ((AI[i].x-1)*LARGEUR+AI[i].dx, (AI[i].y-1)*LARGEUR+AI[i].dy)
      end
   end
   
   pac[anim]:activate ()
   if p.dep==HAUT then
      pac[anim]:draweasy ((p.x-1)*LARGEUR+p.dx, (p.y-1)*LARGEUR+p.dy, pge.math.deg (-90))
   elseif p.dep==BAS then
      pac[anim]:draweasy ((p.x-1)*LARGEUR+p.dx, (p.y-1)*LARGEUR+p.dy, pge.math.deg (90))
   elseif p.dep==GAUCHE then
      pac[anim]:draweasy ((p.x-1)*LARGEUR+p.dx, (p.y-1)*LARGEUR+p.dy, pge.math.deg (180))
   else
      pac[anim]:draweasy ((p.x-1)*LARGEUR+p.dx, (p.y-1)*LARGEUR+p.dy)
   end
   
   pge.gfx.rendertoscreen ()
   pict:activate ()
   if opt.screen==0 then
      pict:draw (0, 0)
   elseif opt.screen==1 then
      pict:draw (0, 0, 272*larg/haut, 272, 0, 0, larg*LARGEUR+1, haut*LARGEUR+1)
   elseif opt.screen==2 then
      pict:draw (0, 0, 480, 272, 0, 0, larg*LARGEUR+1, haut*LARGEUR+1)
   elseif opt.screen==3 then
      pict:draw (0, 0, 480, 272, 0, opt.transy, larg*LARGEUR+1, (larg*LARGEUR+1)*RATIO)
   elseif opt.screen==4 then
      pict:draw (100, 0, larg*LARGEUR, haut*LARGEUR, 0, 0, larg*LARGEUR+1, haut*LARGEUR+1, pge.math.deg (90), 255)
   elseif opt.screen==5 then
      pict:draw (100, -14, 272, 300, 0, 0, larg*LARGEUR+1, haut*LARGEUR+1, pge.math.deg (90), 255)
   elseif opt.screen==6 then
      pict:draw (100, -104, 272, 480, 0, 0, larg*LARGEUR+1, haut*LARGEUR+1, pge.math.deg (90), 255)
   end
   pol2:activate ()
   pol2:print (480-pge.font.measure (pol2, score), 0, blanc, score)
end


function Perdu ()
   pge.gfx.rendertoscreen ()
   pge.gfx.enddrawing ()
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   Dessiner ()
   pol2:activate ()
   pol2:printcenter (135, vert, "You loose")
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   Attendre ()
   Attendre2 ()
   Attendre ()
end


function Gagner ()
   pge.gfx.rendertoscreen ()
   pge.gfx.enddrawing ()
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   Dessiner ()
   pol2:activate ()
   pol2:printcenter (135, rouge, "You win")
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   Attendre ()
   Attendre2 ()
   Attendre ()
end


function Anim (a)
   if a<=2 then
      anim= 1
   elseif a==4 then
      anim= 2
   elseif a==6 then
      anim= 3
   elseif a==8 then
      anim= 4
   elseif a==10 then
      anim= 3
   elseif a==12 then
      anim= 2
   elseif a==14 then
      anim= 1
   end
end


function AfficherScore (val)
   p_score:settarget ()
   pge.gfx.clearscreen ()
   pol2:activate ()
   pol2:print (80-pge.font.measure (pol2, "+" .. val), 0, vert, "+" .. val)
   pge.gfx.rendertoscreen ()
   t_score:update ()
end


function LireNiveaux ()
   pniv= {}
   local f= io.open ("niveau", "rt")
   
   if not f then
      Erreur ("Error: can't find file 'niveau' (program cannot run without it)")
      return false
   end
   pniv[1]= 0
   for line in f:lines () do
      pniv[#pniv+1]= f:seek ("cur")
   end
   f:close ()
end


function Fuite (i)
   local x, y
   local r
   local t= time:peekdelta ()
   while pge.running () do
      r= pge.math.randint (0, 4)
      r= r-2
      if r>=0 then
         r= r+1
      end
      x, y= PlaceSuivante (AI[i].x, AI[i].y, r, false)
      if time:peekdelta ()-t>0.02*opt.speed then
         r= 0
         x, y= PlaceSuivante (AI[i].x, AI[i].y, r, false)
         break
      end
      if y>0 and x>0 and y<=haut and x<=larg and niveau[y][x]<=0 and niveau[y][x]~=P then
          if r~=-AI[i].ancien then
            break
         end
      end
   end
   AI[i].chemin= {r}
end


function Aleatoire (i)
   local x, y
   local r
   local t= time:peekdelta ()
   while pge.running () do
      r= pge.math.randint (0, 4)
      r= r-2
      if r>=0 then
         r= r+1
      end
      x, y= PlaceSuivante (AI[i].x, AI[i].y, r, false)
      if time:peekdelta ()-t>0.02*opt.speed then
         r= 0
         x, y= PlaceSuivante (AI[i].x, AI[i].y, r, false)
         break
      end
      if y>0 and x>0 and y<=haut and x<=larg and niveau[y][x]<=0 and (AI[i].statut=="depart" or niveau[y][x]~=P) and r~=-AI[i].ancien then
         break
      end
   end
   AI[i].chemin= {r}
end


function Transport (x, y)
   if x==transp[pge.math.abs (niveau[y][x])-2].x1 and y==transp[pge.math.abs (niveau[y][x])-2].y1 then
      return transp[pge.math.abs (niveau[y][x])-2].x2, transp[pge.math.abs (niveau[y][x])-2].y2
   else 
      return transp[pge.math.abs (niveau[y][x])-2].x1, transp[pge.math.abs (niveau[y][x])-2].y1
   end
end


function Erreur (msg)
   pge.gfx.enddrawing ()
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   police:activate ()
   police:printcenter (132, blanc, msg)
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   Attendre2 ()
   Attendre ()
end


function IntelliVal (x, y, la, lo, val)
   if val==0 then
      return 0
   end
   if val<0 then
      return val
   end
   if x<1 or x>la or y<1 or y>lo then
      return false
   end
   if ((x==1 or niveau[y][x-1]>0) and (y==1 or niveau[y-1][x]>0) and (x==la or niveau[y][x+1]<=0) and (y==lo or niveau[y+1][x]<=0)) or (x>1 and y>1 and niveau[y-1][x-1]<=0 and niveau[y-1][x]>0 and niveau[y][x-1]>0) then
      return AHG
   end
   if ((y==1 or niveau[y-1][x]>0) and (x==la or niveau[y][x+1]>0) and (x==1 or niveau[y][x-1]<=0) and (y==lo or niveau[y+1][x]<=0)) or (y>1 and x<la and niveau[y-1][x+1]<=0 and niveau[y-1][x]>0 and niveau[y][x+1]>0) then
      return AHD
   end
   if ((y==1 or niveau[y-1][x]<=0) and (x==la or niveau[y][x+1]>0) and (x==1 or niveau[y][x-1]<=0) and (y==lo or niveau[y+1][x]>0)) or (x<la and y<lo and niveau[y+1][x+1]<=0 and niveau[y+1][x]>0 and niveau[y][x+1]>0) then
      return ABD
   end
   if ((y==1 or niveau[y-1][x]<=0) and (x==la or niveau[y][x+1]<=0) and (x==1 or niveau[y][x-1]>0) and (y==lo or niveau[y+1][x]>0)) or (x>1 and y<lo and niveau[y+1][x-1]<=0 and niveau[y+1][x]>0 and niveau[y][x-1]>0) then
      return ABG
   end
   if (x==1 and niveau[y][x+1]<=0) or (x>1 and ((niveau[y][x-1]==0 or niveau[y][x-1]>0) and (x<la and niveau[y][x+1]<0 and niveau[y][x+1]~=P))) then
      return VD
   end
   if (x==la and niveau[y][x-1]<=0) or (x<la and ((niveau[y][x+1]==0 or niveau[y][x+1]>0) and (x>1 and niveau[y][x-1]<0 and niveau[y][x-1]~=P))) then
      return VG
   end
   if (y==1 and niveau[y+1][x]<=0) or (y>1 and ((niveau[y-1][x]==0 or niveau[y-1][x]>0) and (y<lo and niveau[y+1][x]<0))) then
      return HB
   end
   if (y==lo and niveau[y-1][x]<=0) or (y<lo and ((niveau[y+1][x]==0 or niveau[y+1][x]>0) and (y>1 and niveau[y-1][x]<0))) then
      return HH
   end
   return val
end


function Trou (x, y)
   pge.gfx.startdrawing ()
   pict:settarget ()
   pge.gfx.drawrect ((x-1)*LARGEUR-1, (y-1)*LARGEUR-1, LARGEUR+3, LARGEUR+3, noir)
   pge.gfx.rendertoscreen ()
   pge.gfx.enddrawing ()
end


function PlaceSuivante (x, y, mouv, perm)      --donner les coordonnees apres le deplacement 'mouv'
   local a, b
   
   if mouv==DROITE then
      if niveau[y][x]<-3 and perm then
         a, b= Transport (x, y)
         return a+1, b
      end
      return x+1, y
   elseif mouv==GAUCHE then
      if niveau[y][x]<-3 and perm then
         a, b= Transport (x, y)
         return a-1, b
      end
      return x-1, y
   elseif mouv==BAS then
      if niveau[y][x]<-3 and perm then
         a, b= Transport (x, y)
         return a, b+1
      end
      return x, y+1
   elseif mouv==HAUT then
      if niveau[y][x]<-3 and perm then
         a, b= Transport (x, y)
         return a, b-1
      end
      return x, y-1
   else 
      if niveau[y][x]<-3 and perm then
         return Transport (x, y)
      end
      return x, y
   end
end


function DessinerNiveau (perm)
   nbr_attrape= 0
   nbr_tres= 0
   transp= {}
   for i= 1, 7 do
      transp[i]= {x1= false, y1= false, x2= false, y2= false}
   end

   pict:settarget ()
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   for i= 1, #niveau do
      for j= 1, #niveau[i] do
         if niveau[i][j]~=0 then
            DessinerTile (j, i, niveau[i][j], perm)
         end
         if niveau[i][j]==BASE then
            BOITEX, BOITEY= j, i
         end
         if niveau[i][j]==BON then
            niveau[i][j]= 0
            deb.x, deb.y= j, i
         end
         if niveau[i][j]<0 then
            if niveau[i][j]>=-2 then
               if niveau[i][j]==-1 then
                  nbr_tres= nbr_tres+1
               end
            else 
               if transp[pge.math.abs (niveau[i][j])-2].x1 then
                  transp[pge.math.abs (niveau[i][j])-2].x2, transp[pge.math.abs (niveau[i][j])-2].y2= j, i
               else 
                  transp[pge.math.abs (niveau[i][j])-2].x1, transp[pge.math.abs (niveau[i][j])-2].y1= j, i
               end
            end
         end
      end
   end
   pge.gfx.drawrectoutline (0, 0, larg*LARGEUR, haut*LARGEUR-1, rouge)
   pge.gfx.rendertoscreen ()
   pge.gfx.enddrawing ()
end


function DessinerTile (x, y, val, perm)
   if val==0 then
      pge.gfx.drawrect ((x-1)*LARGEUR, (y-1)*LARGEUR, LARGEUR, LARGEUR, blanc)
   elseif val==ABD then
      abd:activate ()
      abd:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==ABG then
      abg:activate ()
      abg:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==AHD then
      ahd:activate ()
      ahd:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==AHG then
      ahg:activate ()
      ahg:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==HH then
      hh:activate ()
      hh:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==HB then
      hb:activate ()
      hb:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==VG then
      vg:activate ()
      vg:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==VD then
      vd:activate ()
      vd:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==CEN then
      cen:activate ()
      cen:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==BASE and perm then
      img[1]:activate ()
      img[1]:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
      yeux[1]:activate ()
      yeux[1]:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==BON and perm then
      bonus.pict:activate ()
      bonus.pict:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==PAC and perm then
      pac[anim]:activate ()
      pac[anim]:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val==PP then
      pge.gfx.drawrect ((x-1)*LARGEUR+3, (y-1)*LARGEUR+3, 2, 2, blanc)
   elseif val==GP then
      pge.gfx.drawrect ((x-1)*LARGEUR+2, (y-1)*LARGEUR+2, 4, 4, blanc)
   elseif val==P then
      hp:activate ()
      hp:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   elseif val<=TRANS and perm then
      trans:activate ()
      trans:draw ((x-1)*LARGEUR, (y-1)*LARGEUR)
   end
end


function LireNombre (str, l)
   local tmp= tonumber (string.sub (str, 1, l))
   if not tmp then
      Erreur ("Unable to read data")
   end
   return tmp, string.sub (str, l+1)
end


function RecreerNiveau (niv, perm)
   local f= io.open ("niveau", "rt")
   local i= 0
   local str
   
   if not f then
      Erreur ("Problem: can't find file 'niveau' (program cannot run without it)")
      return false
   end
   if niv>=#pniv then
      Erreur ("No more level, create your owns!!! \nBy the way: congratulations :)")
      Credits ()
      return false
   end
   if not f then
      Erreur ("Error: can't find file 'niveau' (program cannot run without it)")
      return false
   end
   f:seek ("set", pniv[niv])
   str= f:read ("*line")
   f:close ()
   
   if not str then
      Erreur ("Problem: can't load level "..niv)
      return false
   end
   
   local i= {}
   i= string.match (str, "%<.*%>")
   if #i>2 then
      i= string.gsub (i, "[%<%>]", "")
   else 
      i= ""
   end
   str= string.sub (str, #i+3)
   p.x, str= LireNombre (str, 2)
   p.y, str= LireNombre (str, 2)
   if not p.x or not p.y then
      return false
   end
   
   local j
   la, str= LireNombre (str, 2)
   lo, str= LireNombre (str, 2)
   if not la or not lo then
      return false
   end
   for j= 1, la do
      for k= 1, lo do
         niveau[j][k], str= LireNombre (str, 2)
         if not niveau[j][k] then
            return false
         end
      end
   end
   larg, haut= lo, la
   DessinerNiveau (perm)
   return true
end


function form (a)
   return string.format ("%02d", a)
end


function EnregistrerNiveau (nom, la, lo, lvl)
   local f=io.open ("niveau", "rt")
   local data
   local tmp= 0
   
   if lvl==0 then
      nom= "User"
      data= f:read ("*all")
      f:close ()
      
      f= io.open ("niveau", "wt")
      data= string.gsub (data, "\r", "")
      f:write (data)
      f:write ("<".. nom .. ">".. form (p.x) .. form (p.y))
      f:write (form (lo)..form (la))
      for i= 1, lo do
         for j= 1, la do
            f:write ( string.format ("%02d", niveau[i][j]))
         end
      end
      f:write ("\n")
      f:close ()
   else 
      if lvl>1 then
         data= {f:read (pniv[lvl])}
      else 
         data= {""}
      end
      if lvl<#pniv then
         data[2]= f:seek ("cur")
         tmp= f:seek ("end")
         f:seek ("set", pniv[lvl+1])
         data[3]= f:read (tmp-pniv[lvl+1])
         f:close ()
      end
      line= ""
      line= "<".. nom .. ">".. form (p.x) .. form (p.y)
      line= line .. form (lo)..form (la)
      for i= 1, lo do
         for j= 1, la do
            line= line .. string.format ("%02d", niveau[i][j])
         end
      end
      data[2]= line.."\n"
      f= io.open ("niveau", "wt")
      for i= 1, #data do
         f:write (data[i])
      end
      f:close ()
   end
   LireNiveaux ()
end


function Edit (lvl)
   for i= 1, 17*2 do
      niveau[i]= {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
   end
   local x, y, val= 1, 1, 0
   local la, lo= larg, haut
   local nom= ""
   local sav= false
   local tmp= 0
   
   p.x, p.y= 1, 1
   pict:settarget ()
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   pge.gfx.rendertoscreen ()
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   if lvl>0 then
      RecreerNiveau (lvl, true)
      la, lo= larg, haut
   end
   
   while true do
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      pict:activate ()
      pict:draweasy (0, 0)
      if not sav then
         DessinerTile (x, y, val, true)
      else 
         police:activate ()
         police:printcenter (125, vert, "Save this level?")
         police:printcenter (137, vert, "YES: press (X) Cross")
         police:printcenter (149, vert, "NO: press (O) Circle")
      end
      pge.gfx.drawrectoutline (0, 0, la*LARGEUR-1, lo*LARGEUR-1, rouge)
      
      pac[anim]:activate ()
      pac[anim]:draw ((p.x-1)*LARGEUR, (p.y-1)*LARGEUR)
      
      img[1]:activate ()
      img[1]:draweasy ((BOITEX-1)*LARGEUR, (BOITEY-1)*LARGEUR)
      yeux[1]:activate ()
      yeux[1]:draweasy ((BOITEX-1)*LARGEUR, (BOITEY-1)*LARGEUR)
      
      if niveau[y][x]<=TRANS then
         police:activate ()
         police:print (450, 0, blanc, pge.math.abs (niveau[y][x]+3))
      end
      if val<=TRANS then
         police:activate ()
         police:print (450, 20, rouge, pge.math.abs (val+3))
      end
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      
      pge.controls.update ()
      if pge.controls.pressed (PGE_CTRL_START) then
         if sav then
            sav= false
         else 
            sav= true
         end
      end
      if not sav then
         if (pge.controls.pressed (PGE_CTRL_CROSS) or pge.controls.held (PGE_CTRL_CROSS)) and x<=la and y<=lo then
            tmp= val
            val= IntelliVal (x, y, la, lo, val)
            niveau[y][x]= val
            pge.gfx.startdrawing ()
            pict:settarget ()
            if val~=0 then
               pge.gfx.drawrect ((x-1)*LARGEUR, (y-1)*LARGEUR, LARGEUR, LARGEUR, noir)
               if val==PAC then
                  p.x, p.y= x, y
                  niveau[y][x]= 0
               else
                  if val==BASE then
                     pge.gfx.drawrect ((BOITEX-1)*LARGEUR, (BOITEY-1)*LARGEUR, LARGEUR, LARGEUR, noir)
                     niveau[BOITEY][BOITEX]= 0
                     BOITEX, BOITEY= x, y
                  elseif val==BON then
                     pge.gfx.drawrect ((deb.x-1)*LARGEUR-1, (deb.y-1)*LARGEUR-1, LARGEUR+3, LARGEUR+3, noir)
                     niveau[deb.y][deb.x]= 0
                     deb.x, deb.y= x, y
                  end
                  DessinerTile (x, y, val, true)
               end
            else 
               pge.gfx.drawrect ((x-1)*LARGEUR, (y-1)*LARGEUR, LARGEUR, LARGEUR, noir)
            end
            if val~=PAC and val~=BON then
               for i= 1, 3 do
                  for j= 1, 3 do
                     if x+i-2>=1 and x+i-2<=la and y+j-2>=1 and y+j-2<=lo then
                        val= IntelliVal (x+i-2, y+j-2, la, lo, niveau[y+j-2][x+i-2])
                        niveau[y+j-2][x+i-2]= val
                        if pge.math.fmod ((i+j), 2)~=0 then   --pour faire le tour des quatre points horizontaux et verticaux 
                           if val~=0 then
                              pge.gfx.drawrect ((x+i-2-1)*LARGEUR, (y+j-2-1)*LARGEUR, LARGEUR, LARGEUR, noir)
                              DessinerTile (x+i-2, y+j-2, val, true)
                           else 
                              pge.gfx.drawrect ((x+i-2-1)*LARGEUR, (y+j-2-1)*LARGEUR, LARGEUR, LARGEUR, noir)
                           end
                        end
                     end
                  end
               end
            end
            pge.gfx.rendertoscreen ()
            pge.gfx.enddrawing ()
            val= tmp
         end
         if pge.controls.pressed (PGE_CTRL_LTRIGGER) then
            val= val-1
         end
         if pge.controls.pressed (PGE_CTRL_RTRIGGER) then
            val= val+1
         end
         if val==1 then
            val= 9
         end
         if val==8 then
            val= 0
         end
         if val<-9 then
            val= 12
         end
         if val>12 then
            val= -9
         end
         if pge.controls.pressed (PGE_CTRL_LEFT) or pge.controls.analogx ()<-50 then
            x= x-1
         end
         if pge.controls.pressed (PGE_CTRL_RIGHT) or pge.controls.analogx ()>50 then
            x= x+1
         end
         if x<1 then
            x= #niveau[1]
         end
         if x>#niveau[1] then
            x= 1
         end
         if pge.controls.pressed (PGE_CTRL_UP) or pge.controls.analogy ()<-50 then
            y= y-1
         end
         if pge.controls.pressed (PGE_CTRL_DOWN) or pge.controls.analogy ()>50 then
            y= y+1
         end
         if y<1 then
            y= #niveau
         end
         if y> #niveau then
            y= 1
         end
         if pge.controls.pressed (PGE_CTRL_TRIANGLE) then
            la, lo= x, y
            pict:settarget ()
            pge.gfx.startdrawing ()
            for i= la+1, #niveau[1] do
               for  j= 1, #niveau do
                  pge.gfx.drawrect ((i-1)*LARGEUR, (j-1)*LARGEUR, LARGEUR, LARGEUR, noir)
                  niveau[j][i]= 0
               end
            end
            for i= lo+1, #niveau do
               for  j= 1, #niveau[1] do
                  pge.gfx.drawrect ((j-1)*LARGEUR, (i-1)*LARGEUR, LARGEUR, LARGEUR, noir)
                  niveau[i][j]= 0
               end
            end
            pge.gfx.rendertoscreen ()
            pge.gfx.enddrawing ()
         end
         if pge.controls.held (PGE_CTRL_SELECT) then
            if Assurance ("Quit the editor?", false) then
               return
            end
         end
      else 
         if pge.controls.pressed (PGE_CTRL_CIRCLE) then
            sav= false
         end
         if pge.controls.pressed (PGE_CTRL_CROSS) then
            sav= false
            EnregistrerNiveau (nom, la, lo, lvl)
         end
      end
   end
end


function VerifierPoint (niv, X, Y, x, y, i)         --verifier que le point est etudiable (pathfinding)
   if niv[y][x]<=0 or niv[y][x]==10 and (niv[y][x]~=P or AI[i].statut=="retour" or AI[i].statut=="depart") then
      return true
   end
   return false
end


function ContourPoint (niv, ferm, ouv, X, Y, g, butX, butY, dX, dY, pers)      --trouver les futurs points a etudier (pathfinding)
   local tmp1, tmp2 
   local ouvt
   local x, y
   local r
   
   for i= 1, 3 do
      if dX <= butX then
         x= X+i-2
      else 
         x= X-i+2
      end
      for j= 1, 3 do
         if dY <= butY then
            y= Y+j-2
         else 
            y= Y-j+2
         end
         pge.controls.update ()
         if pge.controls.held (PGE_CTRL_SELECT) or pge.controls.pressed (PGE_CTRL_SELECT) then
            QUITTER= -1
            return
         end
         if pge.math.fmod ((i+j), 2) ~= 0 then   --pour faire le tour des quatre points horizontaux et verticaux 
            if y>0 and y<=haut and x>0 and x<=larg then   --detection des bordures
               if niv[y][x]<-3 then
                  x, y= Transport (x, y)
               end
               if x == butX and y == butY and VerifierPoint (niv, X, Y, x, y, pers) then   --arrivee a destination
                  table.insert (ferm, 1, {
                     x= x,    --abscisse du point etudie
                     y= y,    --coordonnee du point etudie 
                     pax= X,     --abscisse du parent
                     pay= Y,     --coordonnee du parnt
                     g= g+1,                   --distance parcourue
                     h= pge.math.abs (butX-x)+pge.math.abs (butY-y),              --distance a parcourir
                     f=  0  --valeur du point (g+h)
                  })
                  return true
               end
               if VerifierPoint (niv, X, Y, x, y, pers) then
                  if not VerifFerm (ferm, x, y) then                   --si l'element n'a pas deja ete etudie continuer 
                     tmp1= VerifOuv (ouv, x, y)
                     if tmp1 then
                        tmp2= pge.math.abs (butX-x)+pge.math.abs (butY-y) + g+1
                        if tmp2 < ouv[tmp1].f then
                           ouv[tmp1].pax= X
                           ouv[tmp1].pay= Y
                           ouv[tmp1].g= g+1
                           ouv[tmp1].f= tmp2
                        end
                     else 
                        ouvt= {x= x, y= y, pax= X, pay= Y, g= g+1, h= pge.math.abs (butX-x)+pge.math.abs (butY-y), f= 0}
                        ouvt.f= ouvt.g+ouvt.h
                        tmp1= ClassementListeOuverte (ouv, ouvt.f)
                        table.insert (ouv, tmp1, ouvt)
                     end
                  end
               end
            end
         end
      end
   end
   return false
end



function CalculerDeplacement (niv, ferm, ouv, dX, dY, butX, butY, pers)      --boucle principal du pathfinding
   ouv= {{
      x= dX,    --abscisse du point etudie
      y= dY,    --coordonnee du point etudie 
      pax= 0,     --abscisse du parent
      pay= 0,     --coordonnee du parnt
      g= 0,    --distance parcourue
      h= pge.math.abs (butX-dX)+pge.math.abs (butY-dY),    --distance a parcourir
      f= pge.math.abs (butX-dX)+pge.math.abs (butY-dY)   --valeur du point (g+h)
      }}
   ferm= {}
   
   time:update ()
   while #ouv > 0 do
      pge.controls.update ()
      if pge.controls.held (PGE_CTRL_SELECT) or pge.controls.pressed (PGE_CTRL_SELECT) then
         QUITTER= -1
         return
      end
      table.insert (ferm, 1, ouv[1])
      table.remove (ouv, 1)
      if (AI[pers].statut~="retour" and time:peekdelta ()>(0.15*opt.speed)/ENNEMIS) or ContourPoint (niv, ferm, ouv, ferm[1].x, ferm[1].y, ferm[1].g, butX, butY, dX, dY, pers) then
         break
      end
   end

   if #ferm>0 then
      return RetrouverChemin (ferm, dX, dY, butX, butY)
   else 
      return {0}
   end
end


function RetrouverChemin (ferm, dX, dY, butX, butY)      --fin du pathfinding
   local chemin= {}
   local tmp= 1
   local tx, ty= ferm[1].x, ferm[1].y
   local tmpx, tmpy= ferm[1].pax, ferm[1].pay

   while dX~=tx or dY~=ty do
      pge.controls.update ()
      if pge.controls.held (PGE_CTRL_SELECT) or pge.controls.pressed (PGE_CTRL_SELECT) then
         QUITTER= -1
         return
      end
      for i= 1, #ferm do
         if tmpx==ferm[i].x and tmpy==ferm[i].y then
            table.insert (chemin, 1, tx-ferm[i].x-2*(ferm[i].y-ty))
            tx, ty= ferm[i].x, ferm[i].y
            tmpx, tmpy= ferm[i].pax, ferm[i].pay
            table.remove (ferm, i)
            tmp= i
            break
         end
      end
   end
   return chemin
end


function ClassementListeOuverte (ouv, f, mode)       --placer les points a etudier selon leur poids (pathfinding)
   local ran= pge.math.randint (0, 2)
   ran= 0
   for i= 1, #ouv do
      if ran==0 and f <= ouv[i].f then
         return i
      elseif ran==1 and f < ouv[i].f then
         return i
      end
   end
   if #ouv<1 then
      return 1
   end
   return #ouv
end


function VerifFerm (ferm, x, y)   --verifier que l'element n'est pas dans la liste fermee (pathfinding)
   for i= 2, #ferm do   --on commence a 2 car le premier element est celui en cours d'etude
      if ferm[i].x == x and ferm[i].y == y then
         return i
      end
   end
   return false
end


function VerifOuv (ouv, x, y)   --verifier que l'element n'est pas dans la liste ouverte (pathfinding)
   for i= 1, #ouv do
      if ouv[i].x == x and ouv[i].y == y then
         return i
      end
   end
   return false
end


function IA (pers, x, y, butx, buty)      -- (pathfinding)
   local ferm= {}
   local ouv= {}
   
   AI[pers].chemin= CalculerDeplacement (niveau, ferm, ouv, x, y, butx, buty, pers)
   ferm= nil
   ouv= nil
end


function DeplacementPac ()
   if p.dep==DROITE then
      if p.dx >=LARGEUR then
         p.dx= 0
         p.x= p.x+1
      else 
         p.dx= p.dx+STEP
      end
   elseif p.dep==GAUCHE then
      if p.dx <=-LARGEUR then
         p.dx= 0
         p.x= p.x-1
      else 
         p.dx= p.dx-STEP
      end
   elseif p.dep==HAUT then
      if p.dy <=-LARGEUR then
         p.dy= 0
         p.y= p.y-1
      else 
         p.dy= p.dy-STEP
      end
   elseif p.dep==BAS then
      if p.dy >=LARGEUR then
         p.dy= 0
         p.y= p.y+1
      else 
         p.dy= p.dy+STEP
      end
   end
end


function DeplacementAI (pers)
   if AI[pers].dep==DROITE then
      if AI[pers].dx >=LARGEUR then
         AI[pers].dx= 0
         AI[pers].x= AI[pers].x+1
         AI[pers].ancien= AI[pers].dep
      else 
         AI[pers].dx= AI[pers].dx+STEP
      end
   elseif AI[pers].dep==GAUCHE then
      if AI[pers].dx <=-LARGEUR then
         AI[pers].dx= 0
         AI[pers].x= AI[pers].x-1
         AI[pers].ancien= AI[pers].dep
      else 
         AI[pers].dx= AI[pers].dx-STEP
      end
   elseif AI[pers].dep==HAUT then
      if AI[pers].dy <=-LARGEUR then
         AI[pers].dy= 0
         AI[pers].y= AI[pers].y-1
         AI[pers].ancien= AI[pers].dep
      else 
         AI[pers].dy= AI[pers].dy-STEP
      end
   elseif AI[pers].dep==BAS then
      if AI[pers].dy >=LARGEUR then
         AI[pers].dy= 0
         AI[pers].y= AI[pers].y+1
         AI[pers].ancien= AI[pers].dep
      else 
         AI[pers].dy= AI[pers].dy+STEP
      end
   end
end


function Jeu (lvl)
   local tx, ty
   
   if not RecreerNiveau (lvl) then
      return -1
   end
   for i= 1, #AI do
      AI[i].pict= img[i]
   end
   pge.gfx.startdrawing ()
   for i= 1, #AI do
      AI[i].pict_sav:settarget ()
      pict:activate ()
      pict:draw (0, 0, LARGEUR+2, LARGEUR+2, (AI[i].x-1)*LARGEUR+AI[i].dx, (AI[i].y-1)*LARGEUR+AI[i].dy, LARGEUR+2, LARGEUR+2)
      pge.gfx.rendertoscreen ()
   end
   pge.gfx.clearscreen ()
   AdapterVue ()
   Dessiner ()
   pol2:activate ()
   pol2:printcenter (135, vert, "READY")
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   pge.controls.update ()
   Attendre2 ()
   for i= 1, #AI do
      AI[i].time:update ()
   end
   
   if opt.music then
      pge.mp3.loop (true)
      pge.mp3.volume (opt.vol*2000)
      pge.mp3.play ("sons/Milk_Shaker.mp3")
   end
   
   while pge.running () do
      if opt.decalage.val~=0 and opt.decalage.temps:peekdelta ()>opt.decalage.val then
         opt.decalage.val= 0
      end
      
      pge.gfx.startdrawing ()
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      Dessiner ()
      
      if t_score:peekdelta ()<2 then
         p_score:activate ()
         p_score:draw(400, 40, p_score:width (), p_score:height (), 0, 0, p_score:width (), p_score:height (), 0, 255-t_score:peekdelta ()*100)
      end
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      
      pge.gfx.startdrawing ()
      pict:settarget ()
      pge.gfx.drawrectoutline (0, 0, larg*LARGEUR, haut*LARGEUR-1, rouge)
      for i= 1, #AI do
         AI[i].pict_sav:activate ()
         AI[i].pict_sav:draw ((AI[i].x-1)*LARGEUR+AI[i].dx, (AI[i].y-1)*LARGEUR+AI[i].dy)
         if AI[i].dx==0 and AI[i].dy==0 then
            if AI[i].statut=="deb" and AI[i].time:peekdelta ()>TEMPS_S_DEB*i*opt.speed+AI[i].decal then
               AI[i].statut= "depart"
            end
            if AI[i].statut=="dep" and AI[i].time:peekdelta ()>TEMPS_SORTIE*opt.speed+AI[i].decal then
               AI[i].statut= "depart"
            end
            if AI[i].statut=="depart" and niveau[AI[i].y][AI[i].x]==P then
               AI[i].statut= false
            end
            if AI[i].statut=="retour" and niveau[AI[i].y][AI[i].x]==P then
               AI[i].decal= 0
               AI[i].time:update ()
               AI[i].statut= "dep"
               AI[i].pict= img[i]
            end
            if niveau[AI[i].y][AI[i].x]<-3 then
               AI[i].x, AI[i].y= Transport (AI[i].x, AI[i].y)
            end
            if (AI[i].statut~="retour" and AI[i].compt>opt.ia) or #AI[i].chemin<=0 then
               if (p.statut and AI[i].statut=="fuite") or AI[i].statut=="dep"  or AI[i].statut=="deb" then
                  Fuite (i)
               elseif AI[i].statut=="retour" then
                  if niveau[AI[i].y][AI[i].x]~=P and AI[i].time:peekdelta ()<TEMPS_DEP*opt.speed+AI[i].decal then
                     IA (i, AI[i].x, AI[i].y, BOITEX, BOITEY)
                  else
                     AI[i].x, AI[i].y= BOITEX, BOITEY
                     AI[i].decal= 0
                     AI[i].time:update ()
                     AI[i].statut= "dep"
                     Fuite (i)
                     AI[i].pict= img[i]
                  end
               else 
                  if pge.math.abs (p.x-AI[i].x)+pge.math.abs (p.y-AI[i].y)<DETECTION then 
                     if pge.math.randint (0, 3)==0 then
                        Aleatoire (i)
                     else 
                        IA (i, AI[i].x, AI[i].y, p.x, p.y)
                     end
                  else 
                     Aleatoire (i)
                  end
               end
               AI[i].compt= 0
            end
            if pge.controls.pressed (PGE_CTRL_SELECT) then
               QUITTER= -1
            end
            if QUITTER then
               pge.gfx.rendertoscreen ()
               pge.gfx.enddrawing ()
               return QUITTER
            end
            AI[i].compt= AI[i].compt+1
            AI[i].dep= AI[i].chemin[1]
            table.remove (AI[i].chemin, 1)
         end
         DeplacementAI (i)
      end
      pge.gfx.drawrect ((p.x-1)*LARGEUR+p.dx, (p.y-1)*LARGEUR+p.dy, LARGEUR+2, LARGEUR+2, noir)
      for i= 1, #AI do
         AI[i].pict_sav:settarget ()
         pict:activate ()
         pict:draw (0, 0, LARGEUR+2, LARGEUR+2, (AI[i].x-1)*LARGEUR+AI[i].dx, (AI[i].y-1)*LARGEUR+AI[i].dy, LARGEUR+2, LARGEUR+2)
         if pge.math.abs (p.x+p.dx/LARGEUR-(AI[i].x+AI[i].dx/LARGEUR))<0.6 and pge.math.abs (p.y+p.dy/LARGEUR-(AI[i].y+AI[i].dy/LARGEUR))<1 then
            if p.statut and AI[i].statut=="fuite" then
               score= score+cumul
               AfficherScore (cumul)
               cumul= cumul*2
               AI[i].decal= 0
               AI[i].time:update ()
               AI[i].statut= "retour"
               AI[i].chemin= {}
               if opt.sound then
                  attrap:play ()
               end
            elseif AI[i].statut~="retour" then
               Perdu ()
               QUITTER= 1
            end
         end
      end
      pge.gfx.rendertoscreen ()
      pge.gfx.enddrawing ()
      
      if nbr_attrape==nbr_tres then
         Gagner ()
         QUITTER= 2
      end
      
      while time:peekdelta ()<opt.speed*TEMPS_MV do
         pge.controls.update ()
         if pge.controls.pressed (PGE_CTRL_SELECT) then
            QUITTER= -1
         end
         if QUITTER then
            return QUITTER
         end
         if pge.controls.pressed (PGE_CTRL_START) then
            Options ()
         end
         if pge.controls.pressed (PGE_CTRL_LEFT) or pge.controls.analogx ()<-50 then
            if opt.screen>=4 then
               p.f_dep= BAS
            else 
               p.f_dep= GAUCHE
            end
         end
         if pge.controls.pressed (PGE_CTRL_RIGHT) or pge.controls.analogx ()>50 then
            if opt.screen>=4 then
               p.f_dep= HAUT
            else 
               p.f_dep= DROITE
            end
         end
         if pge.controls.pressed (PGE_CTRL_UP) or pge.controls.analogy ()<-50 then
            if opt.screen>=4 then
               p.f_dep= GAUCHE
            else 
               p.f_dep= HAUT
            end
         end
         if pge.controls.pressed (PGE_CTRL_DOWN) or pge.controls.analogy ()>50 then
            if opt.screen>=4 then
               p.f_dep= DROITE
            else 
               p.f_dep= BAS
            end
         end
      end
      time:update ()
      
      pge.controls.update ()
      if pge.controls.pressed (PGE_CTRL_SELECT) then
         QUITTER= -1
      end
      if QUITTER then
         return QUITTER
      end
      if pge.controls.pressed (PGE_CTRL_LEFT) or pge.controls.analogx ()<-50 then
         if opt.screen>=4 then
            p.f_dep= BAS
         else 
            p.f_dep= GAUCHE
         end
      end
      if pge.controls.pressed (PGE_CTRL_RIGHT) or pge.controls.analogx ()>50 then
         if opt.screen>=4 then
            p.f_dep= HAUT
         else 
            p.f_dep= DROITE
         end
      end
      if pge.controls.pressed (PGE_CTRL_UP) or pge.controls.analogy ()<-50 then
         if opt.screen>=4 then
            p.f_dep= GAUCHE
         else 
            p.f_dep= HAUT
         end
      end
      if pge.controls.pressed (PGE_CTRL_DOWN) or pge.controls.analogy ()>50 then
         if opt.screen>=4 then
            p.f_dep= DROITE
         else 
            p.f_dep= BAS
         end
      end
      
      if p.dep==GAUCHE or p.dep==DROITE then
         Anim (pge.math.abs (p.dx))
      end
      if p.dep==HAUT or p.dep==BAS then
         Anim (pge.math.abs (p.dy))
      end

      if p.statut=="attrape" and p.time:peekdelta ()>TEMPS_FANT*opt.speed+opt.decalage.val then
         p.statut= false
         cumul= 200
         for i= 1, #AI do
            AI[i].pict= img[i]
            if AI[i].statut=="fuite" then
               AI[i].statut= false
            end
         end
      end
      if p.statut=="attrape" then
         if p.time:peekdelta ()>(TEMPS_FANT-(NBR_F_CLI*TEMPS_F_CLI))*opt.speed+opt.decalage.val then
            for j= NBR_F_CLI, 0, -1 do
               if p.time:peekdelta ()<(TEMPS_FANT-(j*TEMPS_F_CLI+TEMPS_F_CLI/2))*opt.speed+opt.decalage.val then
                  for i= 1, #AI do
                     if AI[i].statut=="fuite" then
                        AI[i].pict= fant
                     end
                  end
                  break
               elseif p.time:peekdelta ()<(TEMPS_FANT-(j*TEMPS_F_CLI))*opt.speed+opt.decalage.val then
                  for i= 1, #AI do
                     if AI[i].statut=="fuite" then
                        AI[i].pict= fant2
                     end
                  end
                  break
               end
            end
         end
      end
      if p.dx==0 and p.dy==0 then
         if niveau[p.y][p.x]<=0 then
            if niveau[p.y][p.x]==-2 or niveau[p.y][p.x]==-1 then
               if niveau[p.y][p.x]==-2 then
                  score= score+50
                  p.statut= "attrape"
                  for i= 1, #AI do
                     if not AI[i].statut or AI[i].statut=="fuite" then
                        AI[i].pict= fant
                        AI[i].statut= "fuite"
                     end
                  end
                  if opt.sound then
                     pge.wav.play (energ)
                  end
                  p.time:update ()
               else 
                  if opt.sound then
                     pge.wav.play (dot)
                  end
                  score= score+10
                  nbr_attrape= nbr_attrape+1
               end
               niveau[p.y][p.x]= 0
               Trou (p.x, p.y)
            elseif niveau[p.y][p.x]<-3 then
               p.x, p.y= Transport (p.x, p.y)
            end
            tx, ty= PlaceSuivante (p.x, p.y, p.f_dep, false)
            if niveau[p.y][p.x]>=-2 and niveau[ty][tx]<=0 and niveau[ty][tx]~=P then
               if p.f_dep~=0 then
                  p.dep= p.f_dep
                  p.f_dep= 0
               end
            end
         end
         tx, ty= PlaceSuivante (p.x, p.y, p.dep, false)
         if niveau[ty][tx]>0 or niveau[ty][tx]==P then
            p.dep= 0
         end
      end
      DeplacementPac ()
      if pge.controls.pressed (PGE_CTRL_RTRIGGER) then
         opt.screen= opt.screen+1
      end
      if pge.controls.pressed (PGE_CTRL_LTRIGGER) then
         opt.screen= opt.screen-1
      end
      if opt.screen<0 then
         opt.screen= 6
      end
      if opt.screen>6 then
         opt.screen= 0
      end
      if opt.screen==3 then
         AdapterVue ()
      end
   end
end


function Intro ()
   local son= pge.wav.load ("sons/CollerBalle.wav")
   local son2= pge.wav.load ("sons/fin_TV.wav")
   local frac= 5
   
   local logo= pge.texture.load ("images/logo2.png")
   for j= 1, frac do
      for i= 1, 480, 20 do
         pge.gfx.startdrawing ()
         pge.gfx.clearscreen ()
         logo:activate ()
         logo:draw (0, 0, 480, (j-1)*272/frac, 0, 0, logo:width (), (j-1)*logo:height ()/frac, 0, 255)
         if pge.math.fmod (j, 2)==0 then
            logo:draw (i-480, (j-1)*272/frac, 480, 272/frac, 0, (j-1)*logo:height ()/frac, logo:width (), logo:height ()/frac, 0, 255)
         else 
            logo:draw (480-i, (j-1)*272/frac, 480, 272/frac, 0, (j-1)*logo:height ()/frac, logo:width (), logo:height ()/frac, 0, 255)
         end
         pge.gfx.enddrawing ()
         pge.gfx.swapbuffers ()
         pge.controls.update ()
         if pge.controls.pressedany () then
            if opt.sound then
               attrap:play ()
            end
            son= nil
            son2= nil
            return
         end
      end
      if opt.sound then
         pge.wav.play (son)
      end
   end
   
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   logo:activate ()
   logo:draweasy (0, 0)
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   pge.controls.update ()
   
   Attendre2 ()
   Attendre ()
   if opt.sound then
      pge.wav.play (son2)
   end
   local step= 25
   for i= 1, step do
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      logo:activate ()
      logo:draweasy (0, 0)
      pge.gfx.drawrect (0, 0, 480, 272, pge.gfx.createcolor (0, 0, 0, 255*i/step))
      if i<step/2 then
         pge.gfx.drawline (240-480*i/step, 135, 240+480*i/step, 135, pge.gfx.createcolor (155, 155, 255, 155))
         pge.gfx.drawline (240-480*i/step, 136, 240+480*i/step, 136, blanc)
         pge.gfx.drawline (240-480*i/step, 137, 240+480*i/step, 137, pge.gfx.createcolor (155, 155, 255, 155))
      else 
         pge.gfx.drawline (i/step*240, 135, 480-i/step*240, 135, pge.gfx.createcolor (155, 155, 255, 155))
         pge.gfx.drawline (i/step*240, 136, 480-i/step*240, 136, blanc)
         pge.gfx.drawline (i/step*240, 137, 480-i/step*240, 137, pge.gfx.createcolor (155, 155, 255, 155))
      end
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      time:update ()
      while time:peekdelta ()<0.01 do
      end
      pge.controls.update ()
      if pge.controls.pressedany () then
         break
      end
   end
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   pge.gfx.drawrect (239, 135, 3, 3, pge.gfx.createcolor (155, 155, 255, 155))
   pge.gfx.drawrect (240, 136, 1, 1, blanc)
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   pge.controls.update ()
   son= nil
   son2= nil
end


function CompterNiveaux ()
   nbre_niv= 0
   
   local f= io.open ("niveau", "rt")
   if not f then
      return false
   end

   nbre_niv= 0
   for line in f:lines () do
      nbre_niv= nbre_niv + 1
   end
   f:close ()
   return nbre_niv
end


function ChargerStat ()
   local f= io.open ("stats", "rt")
   if not f then
      return false
   end
   
   local str= f:read ("*all")
   max_level, str= LireNombre (str, 3)

   max_score= LireNombre (str, #str)
   
   f:close ()
   return true
end


function EnregistrerStats ()
   local f= io.open ("stats", "wt")
   if not f then
      return false
   end
   if score>=max_score then
      max_score= score
      f:write ( string.format ("%03d%d", max_level, score))
   end

   f:close ()
   return true
end


function Instructions ()
   Attendre ()
   pge.gfx.startdrawing ()
   pge.gfx.clearscreen ()
   pol2:activate ()
   pol2:printcenter (0, rouge, "Level editor")
   police:activate ()
   police:print (0, 35, blanc, "TRIANGLE to set the size of the level")
   police:print (0, 50, blanc, "Left and Right TRIGGER to change patterns")
   police:print (0, 65, blanc, "START to save level")
   police:print (0, 80, blanc, "SELECT to quit the editor")
   police:print (0, 95, blanc, "the yellow crosses are associated to a number (top right of the screen), they are used")
   police:print (0, 110, blanc, "to set gate to go on the other side of the screen.")
   police:print (0, 125, blanc, "the orange box is used to place the ghosts at the beginning.")
   
   police:print (0, 150, rouge, "Beware: there is no verifications about: ")
   police:print (0, 175, blanc, "         - the place of player")
   police:print (0, 190, blanc, "         - modifications outside of the borders")
   pge.gfx.enddrawing ()
   pge.gfx.swapbuffers ()
   Attendre2 ()
   Attendre ()
end


function Credits ()
   local cred= {
      "Toru Iwatani from Namco (conceptor of the game : 'Pan man')",
      "InsertWittyName for developping PGE lua for the PSP",
      "PizzaDude for the 'JellyBelly' font (coolgrafik.com)",
      "Marcel Dadi for the songs 'Milk Shaker' and 'Romantic Sauerkraut'",
      "All website who share sound (unfortunately i can't remember where all sound came)",
      "All people who help(ed) to free the PSP to the good side of the underground."
   }
   
   Attendre ()
   while pge.running () do
      for i= 235, 40, -1 do
         pge.gfx.startdrawing ()
         pge.gfx.clearscreen ()
         logo:activate ()
         logo:draw (0, 0, 480, 272, 0, 0, logo:width (), logo:height (), 0, 30)
         pol2:activate ()
         pol2:printcenter (0, rouge, "Credit goes to:")
         police:activate ()
         for j= 1, #cred do
            police:printcenter (i+(j-1)*210/#cred, blanc, cred[j])
         end
         police:print (0, 250, vert, "Contact me on my blog: samy-prog.blogspot.com")
         pge.gfx.enddrawing ()
         pge.gfx.swapbuffers ()
         
         pge.controls.update ()
         if pge.controls.heldany () then
            Attendre ()
            return
         end
      end
      time:update ()
      while time:peekdelta ()<5 do
         pge.controls.update ()
         if pge.controls.heldany () then
            Attendre ()
            return
         end
      end
   end
end


function Assurance (msg, aff)
   while pge.running () do
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      if aff then
         pict:activate ()
         pict:draweasy (0, 0)
      else 
         logo:activate ()
         logo:draw (0, 0, 480, 272, 0, 0, logo:width (), logo:height (), 0, 30)
      end
      pol2:activate ()
      pol2:printcenter (105, rouge, msg)
      police:activate ()
      police:printcenter (137, vert, "YES: press (X) Cross")
      police:printcenter (149, vert, "NO: press (O) Circle")
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      
      pge.controls.update ()
      if pge.controls.pressed (PGE_CTRL_CIRCLE) then
         return false
      end
      if pge.controls.pressed (PGE_CTRL_CROSS) then
         return true
      end
   end
end


function Attendre ()
   while pge.controls.heldany () or pge.controls.pressedany () do
      pge.controls.update ()
   end
end


function Attendre2 ()
   while not pge.controls.heldany () do
      pge.controls.update ()
   end
end


function PrintTrueFalse (val)
   if val then
      return "On"
   else 
      return "Off"
   end
end


function InvTrueFalse (val)
   if val then
      return false
   else 
      return true
   end
end


function ChoixValeur (msg, dep, min, max, ecart, param)
   local val= dep
   local tmp
   if param then
      tmp= ObtenirNom (dep)
   end
   Attendre ()
   while pge.running () do
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      pol2:activate ()
      pol2:print (0, 50, blanc, msg)
      pol2:print (230, 125, rouge, val)
      if val-1>=min then
         pol2:print (190, 125, pge.gfx.createcolor (155, 0, 0), val-1)
      end
      if val-2>=min then
         pol2:print (150, 125, pge.gfx.createcolor (75, 0, 0), val-2)
      end
      if val+1<=max then
         pol2:print (280, 125, pge.gfx.createcolor (175, 0, 0), val+1)
      end
      if val+2<=max then
         pol2:print (320, 125, pge.gfx.createcolor (75, 0, 0), val+2)
      end
      if param then
         pol2:printcenter (150, vert, tmp)
      end
      police:activate ()
      police:print (0, 230, vert, "Press (X) Cross to accept new value")
      police:print (0, 250, vert, "Press (O) Circle to go back")
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      pge.controls.update ()
      if pge.controls.pressed (PGE_CTRL_CIRCLE) then
         Attendre ()
         return -99
      end
      if pge.controls.pressed (PGE_CTRL_CROSS) then
         Attendre ()
         break
      end
      if pge.controls.pressed (PGE_CTRL_LEFT) or pge.controls.pressed (PGE_CTRL_DOWN) or pge.controls.analogx ()<-50 or pge.controls.analogy ()<-50 then
         if val>min then
            val= val-ecart
            if opt.sound then
               pge.wav.play (dot)
            end
            if param then
               tmp= ObtenirNom (val)
            end
         end
      end
      if pge.controls.pressed (PGE_CTRL_RIGHT) or pge.controls.pressed (PGE_CTRL_UP) or pge.controls.analogx ()>50 or pge.controls.analogy ()>50 then
         if val<max then
            val= val+ecart
            if opt.sound then
               pge.wav.play (dot)
            end
            if param then
               tmp= ObtenirNom (val)
            end
         end
      end
   end
   return val
end


function ObtenirNom (n)
   local tmp= 0
   local f= io.open ("niveau", "rt")
   
   f:seek ("set", pniv[n])
   tmp= string.match (f:read ("*line"), "%<.*%>")
   if tmp then
      if #tmp>2 then
         tmp= string.gsub (tmp, "[%<%>]", "")
      else 
         tmp= "User " .. n
      end
      f:close ()
      return tmp
   end
   return "Error"
end


function Coord (tab, t)
   local g= 9,81
   local ppm= 50
   local tmp= 0
   
   tab.x= tab.x+tab.dx
   if tab.x<=0 or tab.x>=480-8 then
      tab.dx= -tab.dx
   end
   tab.y= tab.y+ (tab.v*ppm*t+((g*ppm*t^2)/2))
   tab.v= tab.v+g*t
   if tab.y>272-8 then
      if tab.v>0 then
         tab.v= -tab.v
      end
      repeat
          tmp= pge.math.randint (-1, 2)
      until pge.math.abs (tab.dx+tmp)<5
      tab.dx= tab.dx+tmp
   end
end


function Options (men)
   if opt.decalage.val~=0 then
      opt.decalage.val= opt.decalage.val-opt.decalage.temps:peekdelta ()
   end
   opt.decalage.temps:update ()
   local place= 1
   local items= {
      {nom= "Music :", val= opt.music, msg= false},
      {nom= "Sounds :", val= opt.sound, msg= false},
      {nom= "Speed :", val= pge.math.floor (50-10*(opt.speed-1)), msg= false},
      {nom= "Life :", val= vies, msg= "(-1 to be immortal)"}
   }
   local tmp
   pge.gfx.enddrawing ()
   Attendre ()
   
   while pge.running () do
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      if not men then
         pict:activate ()
         pict:draw (0, 0, pict:width (), pict:height (), 0, 0, pict:width (), pict:height (), 0, 30)
      end
      pol2:activate ()
      pol2:printcenter (0, rouge, "Options")
      pol2:print (480-pge.font.measure (pol2, vies), 50, blanc, vies)
      pol2:print (480-pge.font.measure (pol2, "Score : " .. score), 90, blanc, "Score : " .. score)
      pac[3]:activate ()
      pac[3]:draw (475-pge.font.measure (pol2, vies)-pac[1]:width ()*2, 53, pac[1]:width ()*2, pac[1]:height ()*2, 0, 0, pac[1]:width (), pac[1]:height (), 0, 255)
      for i= 1, #items do
         if place==i then
            pol2:activate ()
            pol2:print (0, 250/(#items)*i-15, vert, items[i].nom)
            if type (items[i].val)=="boolean" then
               pol2:print (pge.font.measure (pol2, items[i].nom)+10, 250/(#items)*i-15, rouge, PrintTrueFalse (items[i].val))
           else 
              pol2:print (pge.font.measure (pol2, items[i].nom)+10, 250/(#items)*i-15, rouge, items[i].val)
            end
         else 
            police:activate ()
            police:print (0, 250/(#items)*i, blanc, items[i].nom)
            if type (items[i].val)=="boolean" then
               police:print (pge.font.measure (police, items[i].nom)+10, 250/(#items)*i, vert, PrintTrueFalse (items[i].val))
           else 
              police:print (pge.font.measure (police, items[i].nom)+10, 250/(#items)*i, vert, items[i].val)
            end
         end
         if items[i].msg then
            police:activate ()
            police:print (480-pge.font.measure (police, items[i].msg), 250/(#items)*i, blanc, items[i].msg)
         end
      end
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      pge.controls.update ()
      if pge.controls.pressed (PGE_CTRL_START) or pge.controls.pressed (PGE_CTRL_CIRCLE) then
         Attendre ()
         opt.decalage.val= opt.decalage.val+opt.decalage.temps:peekdelta ()
         for i= 1, #AI do
            AI[i].decal= opt.decalage.val
         end
         opt.decalage.temps:update ()
         return
      end
      if pge.controls.pressed (PGE_CTRL_CROSS) then
         if opt.sound then
            pge.wav.play (dot)
         end
         if place==1 then
            items[place].val= InvTrueFalse (items[place].val)
            opt.music= items[place].val
            if items[place].val then
               pge.mp3.loop (true)
               if men then
                  pge.mp3.play ("sons/Romantic_Sauerkraut.mp3")
               else 
                  pge.mp3.play ("sons/Milk_Shaker.mp3")
               end
            else 
               if pge.mp3.isplaying () then
                  pge.mp3.stop ()
               end
            end
         elseif place==2 then
            items[place].val= InvTrueFalse (items[place].val)
            opt.sound= items[place].val
         elseif place==3 then
            tmp= ChoixValeur ("Choose speed of the game : ", items[place].val, 0, 50, 1, false)
            if tmp>=0 then
                items[place].val= tmp
                opt.speed= (50-tmp)/10+1
            end
         elseif place==4 then
            tmp= ChoixValeur ("Choose number of lifes : ", items[place].val, -1, 50, 1, false)
            items[place].val= tmp
            vies= tmp
         end
      end
      if pge.controls.pressed (PGE_CTRL_DOWN) or pge.controls.analogy ()<-50 then
         place= place+1
         if opt.sound then
            pge.wav.play (dot)
         end
      end
      if pge.controls.pressed (PGE_CTRL_UP) or pge.controls.analogy ()>50 then
         place= place-1
         if opt.sound then
            pge.wav.play (dot)
         end
      end
      if place<1 then
         place= #items
      end
      if place>#items then
         place= 1
      end
   end
end


function MenuQuitter ()
   for i= opt.vol, 1, -1 do
      pge.mp3.volume (i*2000)
      pge.gfx.startdrawing ()
      pge.gfx.drawrect (0, 0, 480, 272, pge.gfx.createcolor (0, 0, 0, 255/i))
      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      time:update ()
      while time:peekdelta ()<0.02 do
      end
      pge.controls.update ()
      if pge.controls.pressedany () then
         break
      end
   end
   pge.mp3.volume (opt.vol*2000)
end


function BoucleJeu (lvl)
   local  reuss
   
   while pge.running () do
      QUITTER= false
      nbr_attrape= 0
      p.x= 2
      p.y= 2
      p.dx= 0
      p.dy= 0
      p.dep= 0
      p.f_dep= 0
      p.statut= false
      for i= 1, 4 do
         AI[i].x= BOITEX
         AI[i].y= BOITEY
         AI[i].dx= 0
         AI[i].dy= 0
         AI[i].dep= 0
         AI[i].chemin= {}
         AI[i].compt= i*4
         AI[i].ancien= 0
         AI[i].statut= "deb"
         AI[i].decal=0
         AI[i].time:update ()
      end
      reuss= Jeu (lvl)
      if pge.mp3.isplaying () then
         pge.mp3.stop ()
      end
      
      if reuss==-1 then
         return
      end
      if reuss==1 then
         if vies~=-1 then
            vies= vies-1
         end
         if score>=max_score then
            if not EnregistrerStats () then 
               Erreur ("Can't write file 'stats'")
            end
         end
         if vies<=0 and vies~=-1 then
            score= 0
            pge.gfx.startdrawing ()
            pge.gfx.clearscreen ()
            fond:activate ()
            fond:draweasy (0, 0, 0, 30)
            pol2:activate ()
            pol2:printcenter (125, rouge, "Game over.")
            pge.gfx.enddrawing ()
            pge.gfx.swapbuffers ()
            Attendre2 ()
            Attendre ()
            vies= 5
            break
         end
      end
      if reuss==3 then
         if lvl>1 then
            lvl= lvl-1
         end
      end
      if reuss==2 then
         lvl= lvl+1
         if lvl>max_level then
            max_level= lvl
         end
         if score>max_score then
            max_score= score
         end
      end
   end
end


function Menu ()
   local tab= {}
   local t 
   for i= 1, 4 do
      tab[i]= {x= pge.math.randint (10, 470), y= pge.math.randint (50, 85), dx= pge.math.randint (-2, 3), v= 0, acc= 0, pict= img[i]}
   end
   
   local place= 1
   local x, y= 200, 150
   local X, DX, Y, DY= 0, 2, 0, 1
   local coul, cr, cg, cb, dcr, dcg, dcb= pge.gfx.createcolor (255, 0, 0), 255, 0, 0, 0, 5, 0
   local tmp= 0
   local tp= 0
   local taille= 1
   local item= {{pict= pge.texture.load ("images/nouveau.png", PGE_RAM)},
                {pict= pge.texture.load ("images/charger.png", PGE_RAM)},
                {pict= pge.texture.load ("images/edit.png", PGE_RAM)},
                {pict= pge.texture.load ("images/creer.png", PGE_RAM)},
                {pict= pge.texture.load ("images/options.png", PGE_RAM)},
                {pict= pge.texture.load ("images/credits.png", PGE_RAM)}
                }
   local ratio= item[1].pict:width ()/item[1].pict:height ()
   local lvl= 1

   nbre_niv= CompterNiveaux ()
   if not nbre_niv then
      Erreur ("Can't access the levels in 'niveau'")
   end
   if not ChargerStat () then
      Erreur ("Can't load file 'stats'")
   end
   if opt.music then
      pge.mp3.loop (true)
      pge.mp3.volume (opt.vol*2000)
      pge.mp3.play ("sons/Romantic_Sauerkraut.mp3")
   end
   time:update ()
   while time:peekdelta ()<0.8 do   --attendre la lecture de la musique
   end
   
      
   while pge.running () do
      pge.gfx.startdrawing ()
      pge.gfx.clearscreen ()
      fond:activate ()
      fond:draweasy (0, 0)
      logo:activate ()
      logo:draweasy (0, 0, 0, 50+Y*Y/8)
      
      for i= 1, #tab do      --fantomes bondissants
         if tab[i].x<240 then
            if tab[i].y<y then
               tp= 3
            else 
               tp= 2
            end
         else 
            if tab[i].y<y then
               tp= 4
            else 
               tp= 1
            end
         end
         pge.texture.activate (tab[i].pict) 
         pge.texture.draw (tab[i].pict, tab[i].x, tab[i].y) 
         pge.texture.activate (yeux[tp])
         pge.texture.draw (yeux[tp], tab[i].x, tab[i].y) 
      end
      
      
      bord2:activate ()
      bord2:draweasy (0, 116)
      bord2:draweasy (0, 116)
      
      for i= 1, #item do
         if tmp>0 then
            if i==place-1 then
               taille= 20*pge.math.abs (200-x)/95
            elseif i==place then
               taille= 20-20*pge.math.abs (200-x)/95
            else 
               taille= 0
            end
         elseif tmp<0 then
            if i==place+1 then
               taille= 20*pge.math.abs (200-x)/95
            elseif i==place then
               taille= 20-20*pge.math.abs (200-x)/95
            else 
               taille= 0
            end
         else 
            if i==place then
               taille= 20
            else
               taille= 0
            end
         end
         item[i].pict:activate ()
         item[i].pict:draw (x+(i-place)*95-taille/2, y-(taille*ratio)/2, item[i].pict:width ()+taille, item[i].pict:height ()+taille*ratio, 0, 0, item[i].pict:width (), item[i].pict:height (), 0, 255)
      end
      
      pol3:activate ()
      pol3:print (X, Y, pge.gfx.createcolor (cr, cg, cb), "PUCK MAN")
      
      pol2:activate ()
      pol2:printcenter (60, blanc, "Higher level: ".. max_level)
      pol2:printcenter (85, blanc, "Highscore: ".. max_score)       

      police:activate ()
      police:print (0, 255, blanc, "Written by Samy (C) 2010")

      pge.gfx.enddrawing ()
      pge.gfx.swapbuffers ()
      
      X= X+DX
      if X>=480-pge.font.measure (pol3, "PUCK MAN") or X<=0 then
         DX= -DX
      end
      Y= Y+DY
      if Y>=30 or Y<=0 then
         DY= -DY
      end
      
      cr= cr+dcr
      cg= cg+dcg
      cb= cb+dcb
      
      if (dcr~=0 and (cr==255 or cr==0)) or (dcg~=0 and (cg==255 or cg==0)) or (dcb~=0 and (cb==255 or cb==0)) then
         dcr= 0
         dcg= 0
         dcb= 0
         tp= pge.math.randint (0, 3)
         if tp==0 then
            if cr==255 then
               dcr= -5
            elseif cr==0 then
               dcr= 5
            end
         elseif tp==1 then
            if cg==255 then
               dcg= -5
            elseif cg==0 then 
               dcg= 5
            end
         elseif tp==2 then
            if cb==255 then
               dcb= -5
            elseif cb==0 then
               dcb= 5
            end
         end
      end
      
      
      
      t= time:peekdelta ()
      for i= 1, #tab do
         Coord (tab[i], t)
      end
      time:update ()
      
      pge.controls.update ()
      if (pge.controls.pressed (PGE_CTRL_LEFT) or pge.controls.analogx ()<-50) and place>1 and tmp==0 then
         tmp= 5
      end
      if (pge.controls.pressed (PGE_CTRL_RIGHT) or pge.controls.analogx ()>50) and place<#item and tmp==0 then
         tmp= -5
      end
      if pge.controls.pressed (PGE_CTRL_START)  then
         pict:toram ()
         pict= nil
         MenuQuitter ()
         if pge.mp3.isplaying () then
            pge.mp3.stop ()
         end
         collectgarbage ()
         return
      end

      if pge.controls.pressed (PGE_CTRL_CROSS) and tmp==0 then
         if place==1 then
            if (max_level==1 and score==0) or Assurance ("Highscore will be erased! Continue ?", false) then
               lvl= 1
               max_score= 0
               score= 0
               MenuQuitter ()
               if pge.mp3.isplaying () then
                  pge.mp3.stop ()
               end
               BoucleJeu (lvl)
               if opt.music then
                  pge.mp3.loop (true)
                  pge.mp3.play ("sons/Romantic_Sauerkraut.mp3")
               end
            end
            time:update ()
         elseif place==2 then
            tmp= ChoixValeur ("Choose your level to play : ", lvl, 1, CompterNiveaux (), 1, true)
            score= 0
            if tmp>0 then
               lvl= tmp
               MenuQuitter ()
               if pge.mp3.isplaying () then
                  pge.mp3.stop ()
               end
               BoucleJeu (lvl)
               if opt.music then
                  pge.mp3.loop (true)
                  pge.mp3.play ("sons/Romantic_Sauerkraut.mp3")
               end
            end
            tmp= 0
            time:update ()
         elseif place==3 then
            tmp= ChoixValeur ("Choose your level to edit : ", lvl, 1, CompterNiveaux (), 1, true)
            if tmp>0 then
               Instructions ()
               Instructions ()
               lvl= tmp
               MenuQuitter ()
               if pge.mp3.isplaying () then
                  pge.mp3.stop ()
               end
               Edit (lvl)
               if opt.music then
                  pge.mp3.loop (true)
                  pge.mp3.play ("sons/Romantic_Sauerkraut.mp3")
               end
            end
            tmp= 0
            time:update ()
         elseif place==4 then
            Instructions ()
            Instructions ()
            MenuQuitter ()
            if pge.mp3.isplaying () then
               pge.mp3.stop ()
            end
            Edit (0)
            if opt.music then
               pge.mp3.loop (true)
               pge.mp3.play ("sons/Romantic_Sauerkraut.mp3")
            end
            time:update ()
         elseif place==5 then
            Options (true)
            time:update ()
         elseif place==6 then
            Credits ()
            time:update ()
         end
      end

      x= x+tmp
      if x<=105 then
         x= 200
         tmp= 0
         place= place+1
         if opt.sound then
            pge.wav.play (dot)
         end
      end
      if x>=295 then
         x= 200
         tmp= 0
         place= place-1
         if opt.sound then
            pge.wav.play (dot)
         end
      end
   end
end

Intro ()
LireNiveaux ()
Menu ()
